//////////////////////////////////////////
//
// NOTE: This is *not* a valid shader file
//
///////////////////////////////////////////
Shader "Hidden/TerrainEngine/BillboardTree" {
    Properties {
        _MainTex ("Base (RGB) Alpha (A)", 2D) = "white" { }
    }
    SubShader {
        Tags { "IGNOREPROJECTOR" = "true" "QUEUE" = "Transparent-100" "RenderType" = "TreeBillboard" }
        Pass {
            Tags { "IGNOREPROJECTOR" = "true" "QUEUE" = "Transparent-100" "RenderType" = "TreeBillboard" }
            Blend SrcAlpha OneMinusSrcAlpha, SrcAlpha OneMinusSrcAlpha
            ColorMask RGB 0
            ZWrite Off
            Cull Off
            GpuProgramID 23872
            PlayerProgram "vp" {
                SubProgram "gles3 " {
                    "#ifdef VERTEX
                    #version 300 es
                    
                    #define HLSLCC_ENABLE_UNIFORM_BUFFERS 1
                    #if HLSLCC_ENABLE_UNIFORM_BUFFERS
                    #define UNITY_UNIFORM
                    #else
                    #define UNITY_UNIFORM uniform
                    #endif
                    #define UNITY_SUPPORTS_UNIFORM_LOCATION 1
                    #if UNITY_SUPPORTS_UNIFORM_LOCATION
                    #define UNITY_LOCATION(x) layout(location = x)
                    #define UNITY_BINDING(x) layout(binding = x, std140)
                    #else
                    #define UNITY_LOCATION(x)
                    #define UNITY_BINDING(x) layout(std140)
                    #endif
                    uniform 	vec4 hlslcc_mtx4x4unity_ObjectToWorld[4];
                    uniform 	vec4 hlslcc_mtx4x4unity_MatrixVP[4];
                    uniform 	vec3 _TreeBillboardCameraRight;
                    uniform 	vec4 _TreeBillboardCameraUp;
                    uniform 	vec4 _TreeBillboardCameraFront;
                    uniform 	vec4 _TreeBillboardCameraPos;
                    uniform 	vec4 _TreeBillboardDistances;
                    in highp vec4 in_POSITION0;
                    in mediump vec4 in_COLOR0;
                    in highp vec4 in_TEXCOORD0;
                    in highp vec2 in_TEXCOORD1;
                    out mediump vec4 vs_COLOR0;
                    out highp vec2 vs_TEXCOORD0;
                    vec4 u_xlat0;
                    bool u_xlatb0;
                    vec4 u_xlat1;
                    float u_xlat2;
                    float u_xlat4;
                    void main()
                    {
                        u_xlat0.xyz = in_POSITION0.xyz + (-_TreeBillboardCameraPos.xyz);
                        u_xlat0.x = dot(u_xlat0.xyz, u_xlat0.xyz);
                        u_xlatb0 = _TreeBillboardDistances.x<u_xlat0.x;
                        u_xlat1.xy = in_TEXCOORD1.xy;
                        u_xlat1.z = in_TEXCOORD0.y;
                        u_xlat0.xyz = (bool(u_xlatb0)) ? vec3(0.0, 0.0, 0.0) : u_xlat1.xyz;
                        u_xlat4 = (-u_xlat0.y) + u_xlat0.z;
                        u_xlat2 = _TreeBillboardCameraPos.w * u_xlat4 + u_xlat0.y;
                        u_xlat1.xyz = vec3(_TreeBillboardCameraRight.x, _TreeBillboardCameraRight.y, _TreeBillboardCameraRight.z) * u_xlat0.xxx + in_POSITION0.xyz;
                        u_xlat0.xzw = abs(u_xlat0.xxx) * _TreeBillboardCameraFront.xyz;
                        u_xlat1.xyz = _TreeBillboardCameraUp.xyz * vec3(u_xlat2) + u_xlat1.xyz;
                        u_xlat0.xyz = u_xlat0.xzw * _TreeBillboardCameraUp.www + u_xlat1.xyz;
                        u_xlat1 = u_xlat0.yyyy * hlslcc_mtx4x4unity_ObjectToWorld[1];
                        u_xlat1 = hlslcc_mtx4x4unity_ObjectToWorld[0] * u_xlat0.xxxx + u_xlat1;
                        u_xlat0 = hlslcc_mtx4x4unity_ObjectToWorld[2] * u_xlat0.zzzz + u_xlat1;
                        u_xlat0 = u_xlat0 + hlslcc_mtx4x4unity_ObjectToWorld[3];
                        u_xlat1 = u_xlat0.yyyy * hlslcc_mtx4x4unity_MatrixVP[1];
                        u_xlat1 = hlslcc_mtx4x4unity_MatrixVP[0] * u_xlat0.xxxx + u_xlat1;
                        u_xlat1 = hlslcc_mtx4x4unity_MatrixVP[2] * u_xlat0.zzzz + u_xlat1;
                        gl_Position = hlslcc_mtx4x4unity_MatrixVP[3] * u_xlat0.wwww + u_xlat1;
                        vs_COLOR0 = in_COLOR0;
                        u_xlatb0 = 0.0<in_TEXCOORD0.y;
                        vs_TEXCOORD0.y = u_xlatb0 ? 1.0 : float(0.0);
                        vs_TEXCOORD0.x = in_TEXCOORD0.x;
                        return;
                    }
                    
                    #endif
                    #ifdef FRAGMENT
                    #version 300 es
                    #ifdef GL_EXT_shader_framebuffer_fetch
                    #extension GL_EXT_shader_framebuffer_fetch : enable
                    #endif
                    
                    precision highp float;
                    precision highp int;
                    #define UNITY_SUPPORTS_UNIFORM_LOCATION 1
                    #if UNITY_SUPPORTS_UNIFORM_LOCATION
                    #define UNITY_LOCATION(x) layout(location = x)
                    #define UNITY_BINDING(x) layout(binding = x, std140)
                    #else
                    #define UNITY_LOCATION(x)
                    #define UNITY_BINDING(x) layout(std140)
                    #endif
                    UNITY_LOCATION(0) uniform mediump sampler2D _MainTex;
                    in mediump vec4 vs_COLOR0;
                    in highp vec2 vs_TEXCOORD0;
                    #ifdef GL_EXT_shader_framebuffer_fetch
                    layout(location = 0) inout mediump vec4 SV_Target0;
                    #else
                    layout(location = 0) out mediump vec4 SV_Target0;
                    #endif
                    vec4 u_xlat0;
                    bool u_xlatb1;
                    void main()
                    {
                        u_xlat0 = texture(_MainTex, vs_TEXCOORD0.xy);
                        u_xlatb1 = u_xlat0.w<0.0;
                        if(u_xlatb1){discard;}
                        SV_Target0.xyz = u_xlat0.xyz * vs_COLOR0.xyz;
                        SV_Target0.w = u_xlat0.w;
                        return;
                    }
                    
                    #endif
                    "
                }
                SubProgram "gles3 " {
                    Keywords { "FOG_EXP" }
                    "#ifdef VERTEX
                    #version 300 es
                    
                    #define HLSLCC_ENABLE_UNIFORM_BUFFERS 1
                    #if HLSLCC_ENABLE_UNIFORM_BUFFERS
                    #define UNITY_UNIFORM
                    #else
                    #define UNITY_UNIFORM uniform
                    #endif
                    #define UNITY_SUPPORTS_UNIFORM_LOCATION 1
                    #if UNITY_SUPPORTS_UNIFORM_LOCATION
                    #define UNITY_LOCATION(x) layout(location = x)
                    #define UNITY_BINDING(x) layout(binding = x, std140)
                    #else
                    #define UNITY_LOCATION(x)
                    #define UNITY_BINDING(x) layout(std140)
                    #endif
                    uniform 	vec4 hlslcc_mtx4x4unity_ObjectToWorld[4];
                    uniform 	vec4 hlslcc_mtx4x4unity_MatrixVP[4];
                    uniform 	vec4 unity_FogParams;
                    uniform 	vec3 _TreeBillboardCameraRight;
                    uniform 	vec4 _TreeBillboardCameraUp;
                    uniform 	vec4 _TreeBillboardCameraFront;
                    uniform 	vec4 _TreeBillboardCameraPos;
                    uniform 	vec4 _TreeBillboardDistances;
                    in highp vec4 in_POSITION0;
                    in mediump vec4 in_COLOR0;
                    in highp vec4 in_TEXCOORD0;
                    in highp vec2 in_TEXCOORD1;
                    out mediump vec4 vs_COLOR0;
                    out highp vec2 vs_TEXCOORD0;
                    out highp float vs_TEXCOORD1;
                    vec4 u_xlat0;
                    bool u_xlatb0;
                    vec4 u_xlat1;
                    float u_xlat2;
                    float u_xlat4;
                    void main()
                    {
                        u_xlat0.xyz = in_POSITION0.xyz + (-_TreeBillboardCameraPos.xyz);
                        u_xlat0.x = dot(u_xlat0.xyz, u_xlat0.xyz);
                        u_xlatb0 = _TreeBillboardDistances.x<u_xlat0.x;
                        u_xlat1.xy = in_TEXCOORD1.xy;
                        u_xlat1.z = in_TEXCOORD0.y;
                        u_xlat0.xyz = (bool(u_xlatb0)) ? vec3(0.0, 0.0, 0.0) : u_xlat1.xyz;
                        u_xlat4 = (-u_xlat0.y) + u_xlat0.z;
                        u_xlat2 = _TreeBillboardCameraPos.w * u_xlat4 + u_xlat0.y;
                        u_xlat1.xyz = vec3(_TreeBillboardCameraRight.x, _TreeBillboardCameraRight.y, _TreeBillboardCameraRight.z) * u_xlat0.xxx + in_POSITION0.xyz;
                        u_xlat0.xzw = abs(u_xlat0.xxx) * _TreeBillboardCameraFront.xyz;
                        u_xlat1.xyz = _TreeBillboardCameraUp.xyz * vec3(u_xlat2) + u_xlat1.xyz;
                        u_xlat0.xyz = u_xlat0.xzw * _TreeBillboardCameraUp.www + u_xlat1.xyz;
                        u_xlat1 = u_xlat0.yyyy * hlslcc_mtx4x4unity_ObjectToWorld[1];
                        u_xlat1 = hlslcc_mtx4x4unity_ObjectToWorld[0] * u_xlat0.xxxx + u_xlat1;
                        u_xlat0 = hlslcc_mtx4x4unity_ObjectToWorld[2] * u_xlat0.zzzz + u_xlat1;
                        u_xlat0 = u_xlat0 + hlslcc_mtx4x4unity_ObjectToWorld[3];
                        u_xlat1 = u_xlat0.yyyy * hlslcc_mtx4x4unity_MatrixVP[1];
                        u_xlat1 = hlslcc_mtx4x4unity_MatrixVP[0] * u_xlat0.xxxx + u_xlat1;
                        u_xlat1 = hlslcc_mtx4x4unity_MatrixVP[2] * u_xlat0.zzzz + u_xlat1;
                        u_xlat0 = hlslcc_mtx4x4unity_MatrixVP[3] * u_xlat0.wwww + u_xlat1;
                        gl_Position = u_xlat0;
                        u_xlat0.x = u_xlat0.z * unity_FogParams.y;
                        vs_TEXCOORD1 = exp2((-u_xlat0.x));
                        vs_COLOR0 = in_COLOR0;
                        u_xlatb0 = 0.0<in_TEXCOORD0.y;
                        vs_TEXCOORD0.y = u_xlatb0 ? 1.0 : float(0.0);
                        vs_TEXCOORD0.x = in_TEXCOORD0.x;
                        return;
                    }
                    
                    #endif
                    #ifdef FRAGMENT
                    #version 300 es
                    #ifdef GL_EXT_shader_framebuffer_fetch
                    #extension GL_EXT_shader_framebuffer_fetch : enable
                    #endif
                    
                    precision highp float;
                    precision highp int;
                    #define HLSLCC_ENABLE_UNIFORM_BUFFERS 1
                    #if HLSLCC_ENABLE_UNIFORM_BUFFERS
                    #define UNITY_UNIFORM
                    #else
                    #define UNITY_UNIFORM uniform
                    #endif
                    #define UNITY_SUPPORTS_UNIFORM_LOCATION 1
                    #if UNITY_SUPPORTS_UNIFORM_LOCATION
                    #define UNITY_LOCATION(x) layout(location = x)
                    #define UNITY_BINDING(x) layout(binding = x, std140)
                    #else
                    #define UNITY_LOCATION(x)
                    #define UNITY_BINDING(x) layout(std140)
                    #endif
                    uniform 	mediump vec4 unity_FogColor;
                    UNITY_LOCATION(0) uniform mediump sampler2D _MainTex;
                    in mediump vec4 vs_COLOR0;
                    in highp vec2 vs_TEXCOORD0;
                    in highp float vs_TEXCOORD1;
                    #ifdef GL_EXT_shader_framebuffer_fetch
                    layout(location = 0) inout mediump vec4 SV_Target0;
                    #else
                    layout(location = 0) out mediump vec4 SV_Target0;
                    #endif
                    vec4 u_xlat0;
                    vec3 u_xlat1;
                    bool u_xlatb1;
                    float u_xlat7;
                    void main()
                    {
                        u_xlat0 = texture(_MainTex, vs_TEXCOORD0.xy);
                        u_xlatb1 = u_xlat0.w<0.0;
                        if(u_xlatb1){discard;}
                        u_xlat1.xyz = u_xlat0.xyz * vs_COLOR0.xyz + (-unity_FogColor.xyz);
                        u_xlat7 = vs_TEXCOORD1;
                        u_xlat7 = clamp(u_xlat7, 0.0, 1.0);
                        u_xlat0.xyz = vec3(u_xlat7) * u_xlat1.xyz + unity_FogColor.xyz;
                        SV_Target0 = u_xlat0;
                        return;
                    }
                    
                    #endif
                    "
                }
                SubProgram "gles3 " {
                    Keywords { "FOG_EXP2" }
                    "#ifdef VERTEX
                    #version 300 es
                    
                    #define HLSLCC_ENABLE_UNIFORM_BUFFERS 1
                    #if HLSLCC_ENABLE_UNIFORM_BUFFERS
                    #define UNITY_UNIFORM
                    #else
                    #define UNITY_UNIFORM uniform
                    #endif
                    #define UNITY_SUPPORTS_UNIFORM_LOCATION 1
                    #if UNITY_SUPPORTS_UNIFORM_LOCATION
                    #define UNITY_LOCATION(x) layout(location = x)
                    #define UNITY_BINDING(x) layout(binding = x, std140)
                    #else
                    #define UNITY_LOCATION(x)
                    #define UNITY_BINDING(x) layout(std140)
                    #endif
                    uniform 	vec4 hlslcc_mtx4x4unity_ObjectToWorld[4];
                    uniform 	vec4 hlslcc_mtx4x4unity_MatrixVP[4];
                    uniform 	vec4 unity_FogParams;
                    uniform 	vec3 _TreeBillboardCameraRight;
                    uniform 	vec4 _TreeBillboardCameraUp;
                    uniform 	vec4 _TreeBillboardCameraFront;
                    uniform 	vec4 _TreeBillboardCameraPos;
                    uniform 	vec4 _TreeBillboardDistances;
                    in highp vec4 in_POSITION0;
                    in mediump vec4 in_COLOR0;
                    in highp vec4 in_TEXCOORD0;
                    in highp vec2 in_TEXCOORD1;
                    out mediump vec4 vs_COLOR0;
                    out highp vec2 vs_TEXCOORD0;
                    out highp float vs_TEXCOORD1;
                    vec4 u_xlat0;
                    bool u_xlatb0;
                    vec4 u_xlat1;
                    float u_xlat2;
                    float u_xlat4;
                    void main()
                    {
                        u_xlat0.xyz = in_POSITION0.xyz + (-_TreeBillboardCameraPos.xyz);
                        u_xlat0.x = dot(u_xlat0.xyz, u_xlat0.xyz);
                        u_xlatb0 = _TreeBillboardDistances.x<u_xlat0.x;
                        u_xlat1.xy = in_TEXCOORD1.xy;
                        u_xlat1.z = in_TEXCOORD0.y;
                        u_xlat0.xyz = (bool(u_xlatb0)) ? vec3(0.0, 0.0, 0.0) : u_xlat1.xyz;
                        u_xlat4 = (-u_xlat0.y) + u_xlat0.z;
                        u_xlat2 = _TreeBillboardCameraPos.w * u_xlat4 + u_xlat0.y;
                        u_xlat1.xyz = vec3(_TreeBillboardCameraRight.x, _TreeBillboardCameraRight.y, _TreeBillboardCameraRight.z) * u_xlat0.xxx + in_POSITION0.xyz;
                        u_xlat0.xzw = abs(u_xlat0.xxx) * _TreeBillboardCameraFront.xyz;
                        u_xlat1.xyz = _TreeBillboardCameraUp.xyz * vec3(u_xlat2) + u_xlat1.xyz;
                        u_xlat0.xyz = u_xlat0.xzw * _TreeBillboardCameraUp.www + u_xlat1.xyz;
                        u_xlat1 = u_xlat0.yyyy * hlslcc_mtx4x4unity_ObjectToWorld[1];
                        u_xlat1 = hlslcc_mtx4x4unity_ObjectToWorld[0] * u_xlat0.xxxx + u_xlat1;
                        u_xlat0 = hlslcc_mtx4x4unity_ObjectToWorld[2] * u_xlat0.zzzz + u_xlat1;
                        u_xlat0 = u_xlat0 + hlslcc_mtx4x4unity_ObjectToWorld[3];
                        u_xlat1 = u_xlat0.yyyy * hlslcc_mtx4x4unity_MatrixVP[1];
                        u_xlat1 = hlslcc_mtx4x4unity_MatrixVP[0] * u_xlat0.xxxx + u_xlat1;
                        u_xlat1 = hlslcc_mtx4x4unity_MatrixVP[2] * u_xlat0.zzzz + u_xlat1;
                        u_xlat0 = hlslcc_mtx4x4unity_MatrixVP[3] * u_xlat0.wwww + u_xlat1;
                        gl_Position = u_xlat0;
                        u_xlat0.x = u_xlat0.z * unity_FogParams.x;
                        u_xlat0.x = u_xlat0.x * (-u_xlat0.x);
                        vs_TEXCOORD1 = exp2(u_xlat0.x);
                        vs_COLOR0 = in_COLOR0;
                        u_xlatb0 = 0.0<in_TEXCOORD0.y;
                        vs_TEXCOORD0.y = u_xlatb0 ? 1.0 : float(0.0);
                        vs_TEXCOORD0.x = in_TEXCOORD0.x;
                        return;
                    }
                    
                    #endif
                    #ifdef FRAGMENT
                    #version 300 es
                    #ifdef GL_EXT_shader_framebuffer_fetch
                    #extension GL_EXT_shader_framebuffer_fetch : enable
                    #endif
                    
                    precision highp float;
                    precision highp int;
                    #define HLSLCC_ENABLE_UNIFORM_BUFFERS 1
                    #if HLSLCC_ENABLE_UNIFORM_BUFFERS
                    #define UNITY_UNIFORM
                    #else
                    #define UNITY_UNIFORM uniform
                    #endif
                    #define UNITY_SUPPORTS_UNIFORM_LOCATION 1
                    #if UNITY_SUPPORTS_UNIFORM_LOCATION
                    #define UNITY_LOCATION(x) layout(location = x)
                    #define UNITY_BINDING(x) layout(binding = x, std140)
                    #else
                    #define UNITY_LOCATION(x)
                    #define UNITY_BINDING(x) layout(std140)
                    #endif
                    uniform 	mediump vec4 unity_FogColor;
                    UNITY_LOCATION(0) uniform mediump sampler2D _MainTex;
                    in mediump vec4 vs_COLOR0;
                    in highp vec2 vs_TEXCOORD0;
                    in highp float vs_TEXCOORD1;
                    #ifdef GL_EXT_shader_framebuffer_fetch
                    layout(location = 0) inout mediump vec4 SV_Target0;
                    #else
                    layout(location = 0) out mediump vec4 SV_Target0;
                    #endif
                    vec4 u_xlat0;
                    vec3 u_xlat1;
                    bool u_xlatb1;
                    float u_xlat7;
                    void main()
                    {
                        u_xlat0 = texture(_MainTex, vs_TEXCOORD0.xy);
                        u_xlatb1 = u_xlat0.w<0.0;
                        if(u_xlatb1){discard;}
                        u_xlat1.xyz = u_xlat0.xyz * vs_COLOR0.xyz + (-unity_FogColor.xyz);
                        u_xlat7 = vs_TEXCOORD1;
                        u_xlat7 = clamp(u_xlat7, 0.0, 1.0);
                        u_xlat0.xyz = vec3(u_xlat7) * u_xlat1.xyz + unity_FogColor.xyz;
                        SV_Target0 = u_xlat0;
                        return;
                    }
                    
                    #endif
                    "
                }
            }
        }
    }
}